datablock ParticleData(BanHammerAmbient)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0;
	constantAcceleration = -2.0;
	spinRandomMin        = -300;
	spinRandomMax        = 300;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 250;
	textureName          = "./ban.png";
	colors[0]            = "1 0 0 0";
	colors[1]            = "1 1 1 1";
	colors[2]            = "1 0 0 0.5";
	colors[3]            = "1 0 0 0";
	sizes[0]             = 0.1;
	sizes[1]             = 1.5;
	sizes[2]             = 0.7;
	sizes[3]             = 0.2;
	times[0]             = 0;
	times[1]             = 0.4;
	times[2]             = 0.8;
	times[3]             = 1;
};

datablock ParticleEmitterData(BanHammerAmbientEmitter)
{
	ejectionPeriodMS = 200;
	periodVarianceMS = 100;
	ejectionVelocity = 5;
	velocityVariance = 0;
	ejectionOffset   = 0.4;
	thetaMin         = 5;
	thetaMax         = 25;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance  = false;
	particles        = "BanHammerAmbient";

	uiName = "Banhammer Ambient";
};

datablock ParticleData(BanHammerExplosionParticle)
{
   dragCoefficient      = 3;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0;
   constantAcceleration = 0;
   spinRandomMin	= -500;
   spinRandomMax	= 500;
   lifetimeMS           = 1500;
   lifetimeVarianceMS   = 500;
   textureName          = "./ban.png";
   colors[0]		= "1 1 1 1";
   colors[1]		= "1 0 0 0";
   sizes[0]		= 2;
   sizes[1]		= 0.5;
};

datablock ParticleEmitterData(BanHammerExplosionEmitter)
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BanHammerExplosionParticle";

   uiName = "Banhammer Explosion 1";
};

datablock ParticleData(BanHammerExplosionParticle2)
{
   dragCoefficient      = 1;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0;
   constantAcceleration = 0;
   spinRandomMin	= 0;
   spinRandomMax	= 0.1;
   lifetimeMS           = 3000;
   lifetimeVarianceMS   = 0;
   textureName          = "./ban.png";
   colors[0]		= "1 1 1 1";
   colors[1]		= "1 0 0 0";
   sizes[0]		= 10;
   sizes[1]		= 3;
};

datablock ParticleEmitterData(BanHammerExplosionEmitter2)
{
   ejectionPeriodMS = 500;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BanHammerExplosionParticle2";

   uiName = "Banhammer Explosion 2";
};

datablock ExplosionData(BanHammerExplosion)
{
   lifeTimeMS = 650;

   soundProfile = vehicleExplosionSound;

   particleEmitter = BanHammerExplosionEmitter;
   particleDensity = 75;
   particleRadius = 0.1;

   emitter[0] = BanHammerExplosionEmitter2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "200 200 200";
   camShakeAmp = "5 5 5";
   camShakeDuration = 0.1;
   camShakeRadius = 25;

   lightStartRadius = 10;
   lightEndRadius = 0;
   lightStartColor = "1 1 1 1";
   lightEndColor = "1 0 0 1";

   uiName = "BAN";
};

datablock ProjectileData(BanHammerProjectile)
{
   directDamage        = 500;
   directDamageType  = $DamageType::Hammer;
   radiusDamageType  = $DamageType::Hammer;
   explosion           = BanHammerExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

datablock ItemData(BanHammerItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "Base/Data/Shapes/Hammer.dts";
	mass = 2;
	density = 1;
	elasticity = 0.1;
	friction = 0.9;
	emap = true;

	uiName = "Ban Hammer";
	iconName = "Base/Client/UI/ItemIcons/Hammer";
	doColorShift = true;
	colorShiftColor = "1 0 0 1";

	image = BanHammerImage;
	canDrop = true;
};

datablock ShapeBaseImageData(BanHammerImage)
{
   shapeFile = "Base/Data/Shapes/Hammer.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";

   correctMuzzleVector = false;

   eyeOffset = "0.7 1.2 -0.25";
   className = "WeaponImage";
   item = SwordItem;
   ammo = " ";
   projectile = BanHammerProjectile;
   projectileType = Projectile;
   showBricks = true;

   melee = true;
   doRetraction = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = BanHammerItem.ColorShiftColor;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = playerMountSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	stateEmitter[1]					= BanHammerAmbientEmitter;
	stateEmitterTime[1]				= 600;
	stateEmitterNode[1]				= fire;

	stateName[2]					= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;

	stateName[4]					= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]			= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
};

function BanHammerImage::onPreFire(%this, %obj, %slot) //Makes you swing your arm
{
	%obj.playthread(2, armattack);
}

function BanHammerImage::onStopFire(%this, %obj, %slot) //Makes you stop swinging
{	
	%obj.playthread(2, root);
}