function serverCmdBHMode(%client, %arg) 
{
	if (!%client.isAdmin)
	{
		messageClient(%client, '', "\c6You must be an admin to use this command!");
		return;
	}
	switch$ (%arg) 
	{
		case "kill":
			$Pref::Server::BanHammer_Mode = 0;
			messageAll('MsgAdminForce', '\c3%1\c2 changed the Ban Hammer mode to Kill.', %client.name);
		case "kick":
			$Pref::Server::BanHammer_Mode = 1;
			messageAll('MsgAdminForce', '\c3%1\c2 changed the Ban Hammer mode to Kick.', %client.name);
		case "ban":
			$Pref::Server::BanHammer_Mode = 2;
			messageAll('MsgAdminForce', '\c3%1\c2 changed the Ban Hammer mode to \c0Ban.', %client.name);
		default:
			messageClient(%client, '', "\c6Please enter a valid mode: \"\c0kill\c6\", \"\c0kick\c6\" or \"\c0ban\c6\".");
	}
}

function serverCmdBanHammerMode(%client, %arg)
{
	serverCmdBHMode(%client, %arg);
}

function serverCmdBanHammer(%client) 
{
	if (!%client.isAdmin)
	{
		messageClient(%client, '', "\c6You must be a" @ ($Pref::Server::BanHammer_SuperAdminOnly ? " super admin" : "n admin") @ " to use this command!");
		return;
	}
	
	%client.player.mountImage("BanHammerImage", 0);
}

function BanHammerImage::OnUnMount(%this, %obj) 
{
	%obj.playThread(0, root);
	%obj.playThread(2, root);
	
	if (isObject(%client = %obj.client))
		commandToClient(%obj.client, 'ShowBricks', false);
}

function BanHammerImage::OnMount(%this, %obj) 
{
	%error = "";
	
	// Determine an error (if there is one)
	if (!isObject(%client = %obj.client))								%error = "invalid";
	else if ($Pref::Server::BanHammer_SuperAdminOnly && !%client.isSuperAdmin) %error = "Only super admins can use this tool!";
	else if (!$Pref::Server::BanHammer_SuperAdminOnly && !%client.isAdmin)     %error = "Only admins can use this tool!";
	
	// If there is an error, halt
	if (%error !$= "")
	{
		// Tell the client about the error
		if (isObject(%client))
			messageClient(%client, '', "\c6" @ %error);
		
		// Strip the player of the weapon
		%obj.unMountImage("BanHammerImage");
		%obj.playThread(0, root);
		
		// Promptly exit
		return;
	}
	
	// Otherwise, continue on, brother
	%obj.playThread(0, armReadyRight);
	
	// Don't know why this is being called here, since we're not in a package, but whatever
	Parent::OnMount(%this, %obj); 
}

function BanHammerProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal) 
{
	%mode = $Pref::Server::BanHammer_Mode;
	switch (%mode)
	{
		case 0:
			// 'Kill' mode, formerly 'Destructo' mode
			%isPlayer  = (%col.getClassName() $= "Player" && isObject(%col.client) && %col.client.getClassName() $= "GameConnection");
			%isVehicle = (%col.getClassName() $= "WheeledVehicle");
			%isBot     = (%col.getClassName() $= "AIPlayer") || (%col.getClassName() $= "Player" && isObject(%col.client) && %col.client.getClassName() $= "AIConnection");
			
			// I know I could use typemasks here, but there's really no advantage to doing so since this won't be running
			// every tick
			if (!%isPlayer && !%isVehicle && !%isBot)
				return;
			
			// Do checks for certain things
			if (%isBot)
			{
				// Deny killing serverbot. In fact, just damage the player who tried to kill serverbot
				if (%col.client.bl_id == 999999 && strLwr(%col.client.name) $= "serverbot")
				{
					%obj.sourceObject.Damage(%col, %col.getPosition(), getRandom(10, 20), $DamageType::BanHammer);
					return;
				}
			}
			
			// If there are no special cases, then kill it
			%col.Damage(%obj.sourceObject, %obj.sourceObject.getPosition(), %col.getDataBlock().maxDamage, $DamageType::BanHammer);
			
		case 1:
			// 'Kick' mode
			if (!isObject(%client = %col.client))
				return;
			
			%victimClientID = %client.getID();
			serverCmdKick(%obj.client, %client, %client.bl_id); 
			
		case 2:
			// 'Ban' mode
			if (!isObject(%client = %col.client))
				return;
			
			%BLID      = %client.BL_ID;
			%BanLength = $Pref::Server::BanHammer_BanLength;
			%reason    = $Pref::Server::BanHammer_Reason;
			
			serverCmdBan(%obj.client, %client, %BLID, %BanLength, %reason);
	}
}

if ($DamageType::BanHammer $= "")
	AddDamageType("BanHammer", '<bitmap:base/client/ui/CI/hammer> %1', '%2 <bitmap:base/client/ui/CI/hammer> %1', 1, 0);